using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;
using fatd_faturamento.ENTIDADE;
using fatd_faturamento.DAL.Conexao;

namespace fatd_faturamento.DAL.Persistencia
{
    public class dalGDMovimentacao
    {

        string vFILTER = null;
        string vINNERJOIN = null;
        string vAND = null;
        string vORDERBY = null;

        #region Métodos

        public void Insert(entidadeGDMovimentacao objGDMovimentacao)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {

                    vFILTER = vFILTER + "       DESCRICAO      = ?DESCRICAO , ";
                    vFILTER = vFILTER + "       CODIGO     = ?CODIGO , ";
                    vFILTER = vFILTER + "       VALOR  = ?VALOR , ";
                    vFILTER = vFILTER + "       UNID_ID = ?UNID_ID , ";
                    vFILTER = vFILTER + "       CONS_ID = ?CONS_ID ,";
                    vFILTER = vFILTER + "       ZONA = ?ZONA , ";
                    vFILTER = vFILTER + "       LIVRO = ?LIVRO , ";
                    vFILTER = vFILTER + "       CONTA = ?CONTA , ";
                    vFILTER = vFILTER + "       ANOMES = ?ANOMES , ";
                    vFILTER = vFILTER + "       ANOMES_FAT = ?ANOMES_FAT ";


                    cmd = new MySqlCommand(this.QueryInsert);

                    cmd.Parameters.AddWithValue("?DESCRICAO", objGDMovimentacao.DESCRICAO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CODIGO", objGDMovimentacao.CODIGO);
                    cmd.Parameters.AddWithValue("?VALOR", objGDMovimentacao.VALOR);
                    cmd.Parameters.AddWithValue("?UNID_ID", objGDMovimentacao.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDMovimentacao.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDMovimentacao.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDMovimentacao.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDMovimentacao.CONTA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?ANOMES", objGDMovimentacao.ANOMES);
                    cmd.Parameters.AddWithValue("?ANOMES_FAT", objGDMovimentacao.ANOMES_FAT);

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Update(entidadeGDMovimentacao objGDMovimentacao)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {


                    vFILTER = vFILTER + "       VALOR  = ?VALOR ";

                    vAND = vAND + "AND UNID_ID = ?UNID_ID ";
                    vAND = vAND + "AND CONS_ID = ?CONS_ID ";
                    vAND = vAND + "AND ZONA = ?ZONA ";
                    vAND = vAND + "AND LIVRO = ?LIVRO ";
                    vAND = vAND + "AND CONTA = ?CONTA ";
                    vAND = vAND + "AND CODIGO = ?CODIGO ";
                    vAND = vAND + "AND ANOMES_FAT = ?ANOMES_FAT ";

                    cmd = new MySqlCommand(this.QueryUpdate);

                    cmd.Parameters.AddWithValue("?VALOR", objGDMovimentacao.VALOR);
                    cmd.Parameters.AddWithValue("?UNID_ID", objGDMovimentacao.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDMovimentacao.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDMovimentacao.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDMovimentacao.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDMovimentacao.CONTA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CODIGO", objGDMovimentacao.CODIGO);
                    cmd.Parameters.AddWithValue("?ANOMES_FAT", objGDMovimentacao.ANOMES_FAT);

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public DataTable SelectCount(entidadeGDMovimentacao objGDMovimentacao)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "COUNT(*) ";

                    vINNERJOIN = " ";

                    vORDERBY = " ";

                    if (objGDMovimentacao.UNID_ID != 0)
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND UNID_ID = ?UNID_ID "; }
                        else
                        { vAND = "AND UNID_ID = ?UNID_ID "; }
                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }

                    if (objGDMovimentacao.CONS_ID != 0)
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND CONS_ID = ?CONS_ID "; }
                        else
                        { vAND = "AND CONS_ID = ?CONS_ID "; }
                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }

                    if (!string.IsNullOrEmpty(objGDMovimentacao.ZONA))
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND ZONA = ?ZONA "; }
                        else
                        { vAND = "AND ZONA = ?ZONA "; }
                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }

                    if (!string.IsNullOrEmpty(objGDMovimentacao.LIVRO))
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND LIVRO = ?LIVRO "; }
                        else
                        { vAND = "AND LIVRO = ?LIVRO "; }

                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }


                    if (!string.IsNullOrEmpty(objGDMovimentacao.CONTA))
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND CONTA = ?CONTA "; }
                        else
                        { vAND = "AND CONTA = ?CONTA "; }

                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }


                    if (objGDMovimentacao.CODIGO != 0)
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND CODIGO = ?CODIGO "; }
                        else
                        { vAND = "AND CODIGO = ?CODIGO "; }

                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }

                    if (objGDMovimentacao.ANOMES_FAT != 0)
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + "AND ANOMES_FAT = ?ANOMES_FAT "; }
                        else
                        { vAND = "AND ANOMES_FAT = ?ANOMES_FAT "; }

                    }
                    else
                    {
                        if (!string.IsNullOrEmpty(vAND))
                        { vAND = vAND + " "; }
                        else
                        { vAND = " "; }
                    }

                    cmd = new MySqlCommand(this.QuerySelect);

                    if (objGDMovimentacao.UNID_ID != 0)
                    {
                        cmd.Parameters.AddWithValue("?UNID_ID", objGDMovimentacao.UNID_ID);
                    }

                    if (objGDMovimentacao.CONS_ID != 0)
                    {
                        cmd.Parameters.AddWithValue("?CONS_ID", objGDMovimentacao.CONS_ID);
                    }

                    if (!string.IsNullOrEmpty(objGDMovimentacao.ZONA))
                    {
                        cmd.Parameters.AddWithValue("?ZONA", objGDMovimentacao.ZONA.ToString().ToUpper());
                    }

                    if (!string.IsNullOrEmpty(objGDMovimentacao.LIVRO))
                    {
                        cmd.Parameters.AddWithValue("?LIVRO", objGDMovimentacao.LIVRO.ToString().ToUpper());
                    }

                    if (!string.IsNullOrEmpty(objGDMovimentacao.CONTA))
                    {
                        cmd.Parameters.AddWithValue("?CONTA", objGDMovimentacao.CONTA.ToString().ToUpper());
                    }

                    if (objGDMovimentacao.CODIGO != 0)
                    {
                        cmd.Parameters.AddWithValue("?CODIGO", objGDMovimentacao.CODIGO);
                    }

                    if (objGDMovimentacao.ANOMES_FAT != 0)
                    {
                        cmd.Parameters.AddWithValue("?ANOMES_FAT", objGDMovimentacao.ANOMES_FAT);
                    }

                    dt = objGerenciadorTransacao.GetDataTable(cmd);
                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Delete(entidadeGDMovimentacao objGDMovimentacao)
        {

            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vORDERBY = " ";


                    vAND = vAND + "AND UNID_ID = ?UNID_ID ";
                    vAND = vAND + "AND CONS_ID = ?CONS_ID ";
                    vAND = vAND + "AND ZONA = ?ZONA ";
                    vAND = vAND + "AND LIVRO = ?LIVRO ";
                    vAND = vAND + "AND CONTA = ?CONTA ";
                    vAND = vAND + "AND CODIGO = ?CODIGO ";
                    vAND = vAND + "AND ANOMES_FAT = ?ANOMES_FAT ";


                    cmd = new MySqlCommand(this.QueryDelete);


                    cmd.Parameters.AddWithValue("?UNID_ID", objGDMovimentacao.UNID_ID);
                    cmd.Parameters.AddWithValue("?CONS_ID", objGDMovimentacao.CONS_ID);
                    cmd.Parameters.AddWithValue("?ZONA", objGDMovimentacao.ZONA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?LIVRO", objGDMovimentacao.LIVRO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA", objGDMovimentacao.CONTA.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CODIGO", objGDMovimentacao.CODIGO);
                    cmd.Parameters.AddWithValue("?ANOMES_FAT", objGDMovimentacao.ANOMES_FAT);

                    objGerenciadorTransacao.Execute(cmd);
                }

            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }


        #endregion

        #region " Comandos SQL "

        StringBuilder sb = new StringBuilder();


        protected string QueryInsert
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("INSERT INTO  ");
                this.sb.AppendLine("GD_MOVIMENTACAO SET  ");
                this.sb.AppendLine(vFILTER);

                return sb.ToString();
            }
        }

        protected string QueryUpdate
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("UPDATE  ");
                this.sb.AppendLine("GD_MOVIMENTACAO SET  ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);

                return sb.ToString();
            }
        }

        protected string QueryDelete
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("DELETE FROM GD_MOVIMENTACAO ");
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        protected string QuerySelect
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("SELECT ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("FROM ");
                this.sb.AppendLine("GD_MOVIMENTACAO  ");
                this.sb.AppendLine(vINNERJOIN);
                this.sb.AppendLine("WHERE 1 = 1  ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }


        #endregion


    }
}
